﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace CanvasDrag
{
  public partial class Page : UserControl
  {
    public Page()
    {
      InitializeComponent();
    }

    private UIElement _draggedElement;
    private Point _lastMousePosition;
    
    private void MyRectangle_MouseLeftButtonDown(object sender, 
      MouseButtonEventArgs e)
    {
      _draggedElement = sender as UIElement;
      _lastMousePosition = e.GetPosition(DragCanvas);
    }
    
    private void LayoutRoot_MouseMove(object sender, 
      MouseEventArgs e)
    {
      if (_draggedElement != null)
      {
        Point newPosition = e.GetPosition(DragCanvas);
        double offsetX = newPosition.X - _lastMousePosition.X;
        double offsetY = newPosition.Y - _lastMousePosition.Y;
    
        Canvas.SetTop(_draggedElement,
          Canvas.GetTop(_draggedElement) + offsetY);
        Canvas.SetLeft(_draggedElement, 
          Canvas.GetLeft(_draggedElement) + offsetX);
        _lastMousePosition = newPosition;
      }
    }
    
    private void MyRectangle_MouseLeftButtonUp(object sender, 
      MouseButtonEventArgs e)
    {
      _draggedElement = null;
    }
    
    private void LayoutRoot_MouseLeave(object sender, 
      MouseEventArgs e)
    {
      _draggedElement = null;
    }

  }
}
