﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace ColorChooser
{
  public class MyColor : INotifyPropertyChanged
  {
    #region INotifyPropertyChanged Members
    public event PropertyChangedEventHandler PropertyChanged;
    #endregion

    public Brush MyBrush
    {
      get;
      private set;
    }

    private DateTime _timestamp = DateTime.Now;
    public DateTime Timestamp
    {
      get { return _timestamp; }
      set
      {
        _timestamp = value;
        OnPropertyChanged(new PropertyChangedEventArgs("Timestamp"));
      }
    }

    private string _name;
    public string Name
    {
      get { return _name; }
      set
      {
        _name = value;
        OnPropertyChanged(new PropertyChangedEventArgs("Name"));
      }
    }

    public MyColor(string name, Brush brush)
    {
      Name = name;
      MyBrush = brush;
    }

    private void OnPropertyChanged(PropertyChangedEventArgs e)
    {
      if (PropertyChanged != null)
      {
        PropertyChanged(this, e);
      }
    }
  }
}
