﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using MediaInfo;
using System.Windows.Media.Imaging;
using System.Collections.ObjectModel;

namespace Thumbnails.Data
{
  public class MediaEx : Media
  {
    public Uri FileUri
    {
      get
      {
        return new Uri(
          System.IO.Path.Combine(MediaPath, MediaName).Replace('\\', '/'),
            UriKind.Relative);
      }
    }
    public BitmapImage ImageSource
    {
      get
      {
        return (Type == MediaType.Image)
          ? new BitmapImage(FileUri) : null;
      }
    }
    public Uri MovieUri
    {
      get
      {
        return (Type == MediaType.Movie)
          ? FileUri : null;
      }
    }
  }

  public class MediaExCollection : ObservableCollection<MediaEx>
  {
  }

}
