﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using System.Text;
using UserManagement;

[ServiceContract(Namespace = "http://www.galasoft.ch")]
[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
public class UserManagementService
{
  [OperationContract]
  public UserInformation ValidateUser(string name, string password)
  {
    DataFile dataFile = new DataFile();
    dataFile.LoadUsers();
    UserInformation userInfo = new UserInformation();

    User inputUser = new User();
    inputUser.Name = name;
    inputUser.Password = password;
    if (dataFile.ValidateUser(inputUser))
    {
      User savedUser = dataFile.GetUser(name);
      userInfo.LastVisit = savedUser.LastVisit;
      userInfo.PasswordOk = true;
      savedUser.SetLastVisit();
      dataFile.SaveUsers();
    }
    else
    {
      userInfo.PasswordOk = false;
    }
    return userInfo;
  }

  [OperationContract]
  public string AddUser(string name, string password)
  {
    DataFile dataFile = new DataFile();
    dataFile.LoadUsers();

    try
    {
      User newUser = new User();
      newUser.Name = name;
      newUser.Password = password;
      newUser.SetLastVisit();
      dataFile.AddUser(newUser);
    }
    catch (Exception ex)
    {
      return ex.Message;
    }
    return null; // success
  }
}

[DataContract]
public class UserInformation
{
  [DataMember]
  public bool PasswordOk
  {
    get;
    internal set;
  }

  [DataMember]
  public DateTime? LastVisit
  {
    get;
    internal set;
  }
}
